=== debian/changelog ===
rocr-runtime (6.1.2-3) unstable; urgency=medium

  * Limit architectures to amd64 arm64 ppc64el
  * Add Mario to uploaders

 -- Mario Limonciello <superm1@gmail.com>  Mon, 03 Feb 2025 23:06:11 -0600

rocr-runtime (6.1.2-2) unstable; urgency=medium

  * Add patch to fix FTBFS on arm64, ppc64el.

 -- Christian Kastner <ckk@debian.org>  Fri, 18 Oct 2024 20:28:38 +0200

rocr-runtime (6.1.2-1) unstable; urgency=medium

  * Upload to unstable.

 -- Christian Kastner <ckk@debian.org>  Thu, 17 Oct 2024 16:40:21 +0200

rocr-runtime (6.1.2-1~exp1) experimental; urgency=medium

  [ Xuanteng Huang ]
  * New upstream version 6.1.2
  * Add newly introduced public symbols
  * Refresh patches
  * Add myself to Uploaders

  [ Christian Kastner ]
  * Add myself to Uploaders

 -- Xuanteng Huang <xuanteng.huang@outlook.com>  Mon, 26 Aug 2024 21:29:48 +0800

rocr-runtime (5.7.1-3) unstable; urgency=medium

  [ Cordell Bloor ]
  * d/control: restrict build to 64-bit architectures

  [ Helmut Grohne ]
  * Mark all packages Multi-Arch: same (Closes: #1078913)

  [ Étienne Mollier ]
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Wed, 21 Aug 2024 13:34:47 +0200
