=== debian/control ===
Source: rocr-runtime
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Xuanteng Huang <xuanteng.huang@outlook.com>,
           Christian Kastner <ckk@debian.org>,
           Mario Limonciello <superm1@gmail.com>,
Section: video
Priority: optional
Build-Depends: architecture-is-64-bit,
               clang-17,
               clang-tools-17,
               cmake,
               debhelper-compat (= 13),
               libclang-17-dev,
               libdrm-dev,
               libelf-dev,
               libhsakmt-dev (>= 6.1.2~),
               libmlir-17-dev,
               lld-17,
               llvm-17-dev,
               mlir-17-tools,
               rocm-device-libs-17,
               xxd,
               pkgconf,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
Homepage: https://github.com/ROCm/ROCR-Runtime/
Rules-Requires-Root: no

Package: libhsa-runtime64-1
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.

Package: libhsa-runtime-dev
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Section: libdevel
Depends: libhsa-runtime64-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm - development files
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.
 .
 This package contains the development headers.
